package test;

import java.nio.ByteBuffer;

import mpq.compression.pkware.PKException;
import mpq.compression.pkware.PKExploder;

public class CompressionTest {
	
	/*
	 *    00 04 82 24 25 8f 80 7f
	 *    00000000 00000100 10000010 00100100 00100101 10001111 10000000 01111111
	 *    binary   dict 4  01000001 01001001
	 *
	 * which decompresses to "AIAIAIAIAIAIA" (without the quotes).
	 * 0 binary
	 * 4 dict
	 * 0 text
	 * 01000001 A
	 * 0 text
	 * 01001001 I
	 * 1 stuff
	 */

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// setup compressed buffer
		byte[] raw = {0x00, 0x04, (byte) 0x82, 0x24, 0x25, (byte) 0x8f, (byte) 0x80, 0x7f};
		ByteBuffer compressed = ByteBuffer.wrap(raw);
		int decompressedsize = 13;
		ByteBuffer decompressed = ByteBuffer.allocate(decompressedsize); // should be 13
		
		PKExploder decompressor = new PKExploder();
		try {
			decompressor.explode(compressed, decompressed);
		} catch (PKException e) {
			System.out.println("fail: "+e.getLocalizedMessage());
		}
		
		System.out.println(new String(decompressed.array()));
	}

}
