package test;

import java.io.File;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.Channels;
import java.nio.channels.FileChannel;
import java.nio.channels.SeekableByteChannel;
import java.nio.file.StandardOpenOption;
import java.util.Scanner;

import mpq.ArchivedFile;
import mpq.ArchivedFileExtractor;
import mpq.ArchivedFileStream;
import mpq.HashLookup;
import mpq.MPQException;
import mpq.MPQArchive;

public class TestMPQSource {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		try {
			//SeekableByteChannel source = FileChannel.open(new File("G:\\Experiment2\\Operation Pursuit [OP] 115.w3x").toPath());
			//SeekableByteChannel source = FileChannel.open(new File("G:\\WC3 maps\\dadae.w3x").toPath());
			//SeekableByteChannel source = FileChannel.open(new File("G:\\Experiment2\\SwatAfterP130417.w3x").toPath());
			//SeekableByteChannel source = FileChannel.open(new File("G:\\Experiment2\\EotA_Twilight_1_12c5.w3x").toPath());
			//SeekableByteChannel source = FileChannel.open(new File("G:\\Experiment2\\HeroTestMap.SC2Map").toPath());
			
			SeekableByteChannel source = FileChannel.open(new File("C:\\Program Files (x86)\\Warcraft III\\war3.mpq").toPath());
			//SeekableByteChannel source = FileChannel.open(new File("C:\\Program Files (x86)\\Warcraft III\\War3x.mpq").toPath());
			//SeekableByteChannel source = FileChannel.open(new File("G:\\Experiment2\\Grand Chase Dungeon Arena testing 4.w3x").toPath());
			
			MPQArchive test = new MPQArchive(source);
			ArchivedFileExtractor extractor = new ArchivedFileExtractor();
			
			//MPQArchive.MPQFileStream stream = test.new MPQFileStream(source);
			//HashLookup lookup = new HashLookup("(1)TheDeathSheep.w3m");
			//HashLookup lookup = new HashLookup("war3map.w3e");
			
			//ArchivedFile test3 = test.lookupHash2(new HashLookup("buildings\\Undead\\Ziggurat\\FrostTowerWhat1.wav"));
			
			//HashLookup lookup = new HashLookup("UI\\Glues\\SinglePlayer\\Orc_Exp\\Rexxar.blp");
			HashLookup lookup = new HashLookup("(listfile)");
			ArchivedFile file = test.lookupHash2(lookup);
			//HashLookup lookup = new HashLookup("ReplaceableTextures\\Shadows\\Shadow.blp");
			//System.out.println(new String(lookup.getLookup()));
			//stream.get(lookup);
			
			ArchivedFileStream stream = new  ArchivedFileStream(source, extractor, file);
			Scanner paths = new Scanner(Channels.newInputStream(stream));
			paths.useDelimiter("\r\n");
			//File rootfolder = new File("G:\\Experiment2\\war3");
			//File rootfolder = new File("G:\\Experiment2\\War3x");
			File rootfolder = new File("G:\\Experiment2\\newtest");
			//File rootfolder = new File("G:\\Experiment2\\Grand Chase Dungeon Arena testing 4");
			//int i = 0;
			while( paths.hasNext() ){
				String path = paths.next();
			 
				File newfile = new File(rootfolder, path);
				newfile.getParentFile().mkdirs();
				
				/*if( i == 10436 ){
					System.out.println("10436");
				}*/
				
				try{
					ArchivedFileStream fstream = new  ArchivedFileStream(source, extractor, test.lookupHash2(new HashLookup(path)));
					 
					//ByteBuffer buffer = ByteBuffer.allocate((int) fstream.size());
					//fstream.read(buffer);
					
					fstream.read(ByteBuffer.allocate((int) fstream.size()));
					
					/*if( !newfile.isFile() ) newfile.createNewFile();
					
					FileChannel out = FileChannel.open(newfile.toPath(), StandardOpenOption.WRITE, StandardOpenOption.READ, StandardOpenOption.TRUNCATE_EXISTING);
					try{
						out.transferFrom(fstream, 0, fstream.size());
					}catch( Exception e ){
						if( e instanceof NullPointerException ){
							throw e;
						}
						System.err.print(e);
						newfile.delete();
					}*/
					//MappedByteBuffer out = FileChannel.open(newfile.toPath(), StandardOpenOption.WRITE, StandardOpenOption.READ, StandardOpenOption.TRUNCATE_EXISTING).
					//		map(MapMode.READ_WRITE, 0, fstream.size());
					//while( out.hasRemaining() ) fstream.read(out);
					//out.force();
					//while( buffer.hasRemaining() ) out.write(buffer);
					//out.close();
					fstream.close();
					
					System.out.println("extracted file: " + path);
				}catch( MPQException | IOException e ){
					System.out.println("invalid archive: " + path);
					System.out.println(e.getLocalizedMessage());
				}
				//i+= 1;
			 }
			 paths.close();
			 
			 
			//ByteBuffer
			
			
			/*File newfile = new File("G:\\Experiment2\\listfile2.txt");
			if( !newfile.isFile() ) newfile.createNewFile();
			MappedByteBuffer out = FileChannel.open(newfile.toPath(), StandardOpenOption.WRITE, StandardOpenOption.READ, StandardOpenOption.TRUNCATE_EXISTING).
					map(MapMode.READ_WRITE, 0, stream.size());
			while( out.hasRemaining() ) stream.read(out);
			out.force();*/
			
			stream.close();
			
			/*for(int i = 0 ; i < stream.size() ; i+= 1<<12){
				System.out.println("current position: " + i);
				stream.position(i);
			}*/
			

			//Entry[] hash = test.getHashTable();
			//Block[] blocktable = test.getBlockTable();
			//int index = test.lookupPath("war3map.shd");
			//int[] offtable = test.getOffsetTable(blocktable[index]);
			//System.out.printf("war3map.w3e at block index %d%n", index);
			//index = test.lookupPath("war3map.wpm");
			//System.out.printf("war3map.w3e at block index %d%n", index);
			//index = test.lookupPath("war3map.w3e");
			//System.out.printf("war3map.w3e at block index %d%n", index);
			//System.out.println(BlockTable.flagsToString(blocktable[index].getFlags()));
			//System.out.println(offtable);
			System.out.println(test);
			System.out.println("DONE");
		} catch (MPQException | IOException e) {
			e.printStackTrace();
			System.out.println("Fail");
		}

	}

}
